--[[Hooks:PostHook( HUDManager , "_create_teammates_panel" , "uHUDPostHUDManagerCreateTeammatesPanel" , function( self , hud )

	if not uHUD:HasSetting( "big_lobby" ) then return end
	
	hud = hud or managers.hud:script( PlayerBase.PLAYER_INFO_HUD_PD2 )
	
	self._hud.teammate_panels_data = self._hud.teammate_panels_data or {}
	self._teammate_panels = {}
	
	if hud.panel:child( "teammates_panel" ) then
		hud.panel:remove( hud.panel:child( "teammates_panel" ) )
	end
	
	local h = self:teampanels_height()
	
	local teammates_panel = hud.panel:panel({
		name = "teammates_panel",
		h = h,
		y = hud.panel:h() - h,
		halign = "grow",
		valign = "bottom"
	})
	
	local teammate_w = 204
	local player_gap = 240
	local small_gap = ( teammates_panel:w() - player_gap - teammate_w * HUDManager.PLAYER_PANEL ) / ( HUDManager.PLAYER_PANEL - 1 )
	
	for i = 1 , HUDManager.PLAYER_PANEL do
	
		local is_player = i == HUDManager.PLAYER_PANEL
		do break end -- unhandled boolean indicator
		
		self._hud.teammate_panels_data[i] = {
			taken = true,
			special_equipments = {}
		}
		
		local pw = teammate_w + ( is_player and 0 or 64 )
		local teammate = HUDTeammate:new( i , teammates_panel , is_player , pw )
		local x = math.floor( ( pw + small_gap ) * ( i - 1 ) + ( i == HUDManager.PLAYER_PANEL and player_gap or 0 ) )
		
		teammate._panel:set_x( math.floor( x ) )
		table.insert( self._teammate_panels , teammate )
		
		if is_player then
			teammate:add_panel()
		end
		
	end

end ) ]]

function HUDManager:get_panel_by_peer_id( peer_id )

	for panel , data in pairs( self._teammate_panels ) do
		if data._peer_id == peer_id then
			return panel
		end
	end

end

function HUDManager:get_panel_by_mugshot_id( mug_id )

	for i , criminal in pairs( managers.criminals:characters() ) do
		if criminal.data.mugshot_id == mug_id then
			return criminal.data.panel_id
		end
	end

end

Hooks:PreHook( HUDManager , "set_stamina_value" , "uHUDPostHUDManagerSetStaminaValue" , function( self , value )

	self._teammate_panels[ HUDManager.PLAYER_PANEL ]:set_stamina_value( value )

end )

Hooks:PreHook( HUDManager , "set_max_stamina" , "uHUDPostHUDManagerSetMaxStamina" , function( self , value )

	self._teammate_panels[ HUDManager.PLAYER_PANEL ]:set_max_stamina( value )

end )

Hooks:PostHook( HUDManager , "set_mugshot_talk" , "uHUDPostHUDManagerSetMugshotTalk" , function( self , id , active )

	if not uHUD:HasSetting( "character_talk" ) then return end
	
	local panel_id = self:get_panel_by_mugshot_id( id )
	
	if not panel_id then return end
	self._teammate_panels[ panel_id ]:set_voice( active , "talk" )

end )

Hooks:PostHook( HUDManager , "set_mugshot_voice" , "uHUDPostHUDManagerSetMugshotVoice" , function( self , id , active )

	local panel_id = self:get_panel_by_mugshot_id( id )
	
	if not panel_id then return end
	self._teammate_panels[ panel_id ]:set_voice( active , "voice" )

end )

function HUDManager:set_mugshot_talk_local( active )

	self._teammate_panels[ HUDManager.PLAYER_PANEL ]:set_voice( active )

end

function HUDManager:update_downed_counter( value )

	self._teammate_panels[ HUDManager.PLAYER_PANEL ]:set_downed( value )
	
end

function HUDManager:show_underdog()

	if not uHUD:HasSetting( "underdog" ) then
		self._teammate_panels[ HUDManager.PLAYER_PANEL ]:hide_underdog()
		return
	end
	
	self._teammate_panels[ HUDManager.PLAYER_PANEL ]:show_underdog()

end

function HUDManager:hide_underdog()

	self._teammate_panels[ HUDManager.PLAYER_PANEL ]:hide_underdog()

end

function HUDManager:show_armor_timer( time )

	if not uHUD:HasSetting( "armour_timer" ) then
		self._teammate_panels[ HUDManager.PLAYER_PANEL ]:hide_armor_timer()
		return
	end
	
	self._teammate_panels[ HUDManager.PLAYER_PANEL ]:show_armor_timer( time )

end

function HUDManager:hide_armor_timer()

	self._teammate_panels[ HUDManager.PLAYER_PANEL ]:hide_armor_timer()

end

function HUDManager:show_reload_timers( index , time )

	if not uHUD:HasSetting( "reload_timer" ) then
		self._teammate_panels[ HUDManager.PLAYER_PANEL ]:hide_reload_timers( index )
		return
	end
	
	self._teammate_panels[ HUDManager.PLAYER_PANEL ]:show_reload_timers( index , time )

end

function HUDManager:hide_reload_timers( index )

	self._teammate_panels[ HUDManager.PLAYER_PANEL ]:hide_reload_timers( index )

end

function HUDManager:update_kill_counter( weapon , total )

	self._teammate_panels[ HUDManager.PLAYER_PANEL ]:update_kill_counter( weapon , total )

end

function HUDManager:sync_doctor_bag_taken( panel )

	self._teammate_panels[ panel ]:sync_doctor_bag_taken()

end

function HUDManager:on_peer_downed( panel )

	self._teammate_panels[ panel ]:on_peer_downed()

end

function HUDManager:set_bulletstorm( state )

	self._teammate_panels[ HUDManager.PLAYER_PANEL ]:_set_bulletstorm( state )

end