function PlayerStandard:clbk_sprint_delay_expire()

	self._sprint_delay = nil
	
	if self._running and not self._end_running_expire_t and not self:_is_reloading() and not self._shooting and not self._camera_unit:base()._melee_item_units then
		self._ext_camera:play_redirect( self.IDS_START_RUNNING )
	end

end

function PlayerStandard:clbk_idle_inspect_expire()

	self._idle_inspect = nil
	
	local action_forbidden = self:_interacting() or self:is_deploying() or self:_changing_weapon() or self:_is_throwing_projectile() or self:_is_meleeing() or self:_on_zipline() or self:running() or self:_is_reloading() or self:in_steelsight() or self:is_equipping() or self:shooting() or self:_is_cash_inspecting( t ) or not self._state_data.mask_equipped
	
	if not action_forbidden then
		self._ext_camera:play_redirect( self.IDS_CASH_INSPECT )
	end

end

Hooks:PostHook( PlayerStandard , "_update_movement" , "uHUDPostPlayerStandardUpdateMovement" , function( self , t , dt )

	if uHUD:HasSetting( "idle_inspect" ) then
	
		if not self._moving then
			if not self._idle_inspect then
				self._idle_inspect = {
					id = "uHUDIdleInspect"
				}
				managers.enemy:add_delayed_clbk( self._idle_inspect.id , callback( self , self , "clbk_idle_inspect_expire" ) , TimerManager:game():time() + math.random( 15 , 20 ) )
			end
		elseif self._moving and self._idle_inspect then
			managers.enemy:reschedule_delayed_clbk( self._idle_inspect.id , TimerManager:game():time() + math.random( 5 , 10 ) )
		end
		
	end

end )

Hooks:PostHook( PlayerStandard , "_update_reload_timers" , "uHUDPostPlayerStandardUpdateReloadTimers" , function( self , t , dt , input )

	if self._state_data.reload_expire_t then
		managers.hud:show_reload_timers( self._equipped_unit:base():selection_index() , ( self._state_data.reload_expire_t - t ) )
	else
		managers.hud:hide_reload_timers( self._equipped_unit:base():selection_index() )
	end

end )

Hooks:PostHook( PlayerStandard , "_start_action_equip_weapon" , "uHUDPostPlayerStandardStartActionEquipWeapon" , function( self , t )

	local weapon = self._equipped_unit:base()
	
	if weapon then
		local canted = weapon and weapon.is_second_sight_on and weapon:is_second_sight_on()
		if canted then
			managers.enemy:add_delayed_clbk( "canted_sights" , function() managers.player:player_unit():camera()._camera_unit:base():_check_canted_sights() end , Application:time() + 0.01 )
		end
	end

end )

Hooks:PostHook( PlayerStandard , "_start_action_running" , "uHUDPostPlayerStandardStartActionRunning" , function( self , t )

	if uHUD:HasSetting( "sprint_delay" ) then
	
		if ( not self:_is_reloading() or not self.RUN_AND_RELOAD ) and not self._camera_unit:base()._melee_item_units then
			if not self.RUN_AND_SHOOT then
				self._ext_camera:play_redirect( self.IDS_IDLE )
			end
		end
	
		if self._sprint_delay then
			managers.enemy:reschedule_delayed_clbk( self._sprint_delay.id , TimerManager:game():time() + 1.25 )
		else
			self._sprint_delay = {
				id = "uHUDSprintDelay"
			}
			managers.enemy:add_delayed_clbk( self._sprint_delay.id , callback( self , self , "clbk_sprint_delay_expire" ) , TimerManager:game():time() + 1 )
		end
	
	end

end )

Hooks:PostHook( PlayerStandard , "_end_action_running" , "uHUDPostPlayerStandardEndActionRunnung" , function( self , t )

	if self._sprint_delay and not self._camera_unit:base()._melee_item_units then
		self._ext_camera:play_redirect( self.IDS_IDLE )
	end

end )

Hooks:PreHook( PlayerStandard , "set_running" , "uHUDPrePlayerStandardSetRunning" , function( self , running )

	if not self.RUN_AND_SHOOT and running then
		managers.player:player_unit():camera()._camera_unit:base():_check_canted_sights( true )
	else
		managers.player:player_unit():camera()._camera_unit:base():_check_canted_sights()
	end

end )

Hooks:PreHook( PlayerStandard , "_end_action_running" , "uHUDPrePlayerStandardEndActionRunning" , function( self , t , input , complete )

	if self._running and not self._end_running_expire_t and not self.RUN_AND_SHOOT then
		managers.player:player_unit():camera()._camera_unit:base():_check_canted_sights()
	end

end )

Hooks:PostHook( PlayerStandard , "_start_action_reload" , "uHUDPostPlayerStandardStartActionReload" , function( self , t )

	managers.player:player_unit():camera()._camera_unit:base():_check_canted_sights( true )

end )

Hooks:PreHook( PlayerStandard , "_interupt_action_reload" , "uHUDPrePlayerStandardInteruptActionReload" , function( self , t )

	if self:_is_reloading() then
		managers.player:player_unit():camera()._camera_unit:base():_check_canted_sights()
	end

end )

Hooks:PostHook( PlayerStandard , "_update_fwd_ray" , "uHUDPostPlayerStandardUpdateFwdRay" , function( self )

	if not uHUD:HasSetting( "enemy_health" ) then
		managers.hud:set_unit_health_visible( false )
		return
	end
	
	if self._last_unit then
	
		local iAngle = 360
		local cAngle = 360
		
		iAngle = self:getUnitRotation( self._last_unit )
		
		if iAngle then
			
			cAngle = cAngle + ( iAngle - cAngle )
			
			if cAngle == 0 then cAngle = 360 end
		
			managers.hud:set_unit_health_rotation( cAngle )
			
		end
		
	end
	
	if self._fwd_ray and self._fwd_ray.unit then
	
		local unit = self._fwd_ray.unit
		
		if unit:in_slot( 8 ) and alive( unit:parent() ) then
			unit = unit:parent()
		end
		
		if managers.groupai:state():turrets() then
			for _ , t_unit in pairs( managers.groupai:state():turrets() ) do
				if alive( t_unit ) and t_unit:movement():team().foes[ managers.player:player_unit():movement():team().id ] and unit == t_unit then
					unit = t_unit
				end
			end
		end
		
		if alive( unit ) and unit:character_damage() and not unit:character_damage()._dead and not managers.enemy:is_civilian( unit ) and managers.enemy:is_enemy( unit ) and unit:base() and unit:base()._tweak_table then
			
			self._last_unit = unit
			managers.hud:set_unit_health_visible( true )
			managers.hud:set_unit_health( unit:character_damage()._health or 0 , unit:character_damage()._HEALTH_INIT or 0 , unit:base()._tweak_table or "cop" )
			
		else
		
			if self._last_unit and alive( self._last_unit ) then
				managers.hud:set_unit_health( self._last_unit:character_damage()._health or 0 , self._last_unit:character_damage()._HEALTH_INIT or 0 , self._last_unit:base()._tweak_table or "cop" )
				managers.hud:set_unit_health_visible( false )
				return
			end
			
		end
		
	else
	
		if self._last_unit and alive( self._last_unit ) then
			managers.hud:set_unit_health( self._last_unit:character_damage()._health or 0 , self._last_unit:character_damage()._HEALTH_INIT or 0 , self._last_unit:base()._tweak_table or "cop" )
			managers.hud:set_unit_health_visible( false )
			return
		end
		
	end

end )

Hooks:PostHook( PlayerStandard , "_update_check_actions" , "uHUDPostPlayerStandardUpdateCheckActions" , function( self , t , dt )

	if self._camera_unit:base()._melee_item_units then
	
		managers.hud:update_kill_counter( managers.statistics:session_killed_by_melee() , managers.statistics:session_total_kills() )
		
	elseif not self._camera_unit:base()._melee_item_units then
		
		managers.hud:update_kill_counter( managers.statistics:session_killed_by_weapon( self._ext_inventory:equipped_unit():base():get_name_id() ) , managers.statistics:session_total_kills() )
		
	end

end )

function PlayerStandard:getUnitRotation( unit )

	if not unit or not alive( unit ) then return 360 end
	
	local unit_position = unit:position()
	local vector = self._camera_unit:position() - unit_position
	local forward = self._camera_unit:rotation():y()
	local rotation = math.floor( vector:to_polar_with_reference( forward , math.UP ).spin )
	
	return -( rotation + 180 )

end