local function CharacterID( n )

	for i , p in pairs( tweak_data.criminals.characters ) do
		if p.name == n then return i end
	end

end

Hooks:PostHook( UnitNetworkHandler , "sync_doctor_bag_taken" , "uHUDPostUnitNetworkHandlerSyncDoctorBagTaken" , function( self , unit , amount , sender )

	local peer = self._verify_sender( sender )
	local peer_id = peer and peer:id()
	
	if not peer_id then return end
	
	managers.hud:sync_doctor_bag_taken( managers.hud:get_panel_by_peer_id( peer_id ) )

end )

Hooks:PostHook( UnitNetworkHandler , "say" , "uHUDPostUnitNetworkHandlerSay" , function( self , unit , event_id , sender )

	if not alive( unit ) or not self._verify_gamestate( self._gamestate_filter.any_ingame ) or not self._verify_sender( sender ) then
		return
	end
	
	if not alive( managers.player:player_unit() ) then
		return
	end
	
	if event_id == SoundDevice:string_to_id( "f21" .. tweak_data.criminals.characters[ CharacterID( managers.criminals:local_character_name() ) ].static_data.ssuffix .. "_sin" ) then
		managers.player:player_unit():sound():say( "r01x_sin" , true , true )
	elseif event_id == ( SoundDevice:string_to_id( "f11" .. tweak_data.criminals.characters[ CharacterID( managers.criminals:local_character_name() ) ].static_data.ssuffix .. "_sin" ) or SoundDevice:string_to_id( "f13" .. tweak_data.criminals.characters[ CharacterID( managers.criminals:local_character_name() ) ].static_data.ssuffix .. "_sin" ) ) then
		managers.player:player_unit():sound():say( "r02a_sin" , true , true )
	end

end )

Hooks:PostHook( UnitNetworkHandler , "unit_sound_play" , "uHUDPostUnitNetworkHandlerUnitSoundPlay" , function( self , unit , event_id , source , sender )

	if not alive( unit ) or not self._verify_sender( sender ) then
		return
	end
	
	if not alive( managers.player:player_unit() ) then
		return
	end
	
	if event_id == SoundDevice:string_to_id( "f21" .. tweak_data.criminals.characters[ CharacterID( managers.criminals:local_character_name() ) ].static_data.ssuffix .. "_sin" ) then
		managers.player:player_unit():sound():say( "r01x_sin" , true , true )
	elseif event_id == ( SoundDevice:string_to_id( "f11" .. tweak_data.criminals.characters[ CharacterID( managers.criminals:local_character_name() ) ].static_data.ssuffix .. "_sin" ) or SoundDevice:string_to_id( "f13" .. tweak_data.criminals.characters[ CharacterID( managers.criminals:local_character_name() ) ].static_data.ssuffix .. "_sin" ) ) then
		managers.player:player_unit():sound():say( "r02a_sin" , true , true )
	end

end )

Hooks:PostHook( UnitNetworkHandler , "long_dis_interaction" , "uHUDPostUnitNetworkHandlerLongDisInteraction" , function( self , target_unit , amount , aggressor_unit )

	if not self._verify_gamestate( self._gamestate_filter.any_ingame ) or not self._verify_character( target_unit ) or not self._verify_character( aggressor_unit ) then
		return
	end
	
	if not alive( target_unit ) then
		return
	end
	
	local target_is_criminal = target_unit:in_slot( managers.slot:get_mask( "criminals" ) ) or target_unit:in_slot( managers.slot:get_mask( "harmless_criminals" ) )
	local aggressor_is_criminal = aggressor_unit:in_slot( managers.slot:get_mask( "criminals" ) ) or aggressor_unit:in_slot( managers.slot:get_mask( "harmless_criminals" ) )
	
	if target_is_criminal and target_unit:key() == managers.player:player_unit():key() then
		if aggressor_is_criminal then
			if amount == 1 then
				managers.player:player_unit():sound():say( "r01x_sin" , true , true )
			end
		end
	end

end )